##############################################################################
#
# Copyright (c) 2008 Zope Corporation. All Rights Reserved.
#
# This software is subject to the provisions of the Zope Visible Source
# License, Version 1.0 (ZVSL).  A copy of the ZVSL should accompany this
# distribution.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################

from Testing import ZopeTestCase
from Testing.ZopeTestCase.functional import Functional
from Products.PloneTestCase import PloneTestCase

PloneTestCase.setupPloneSite()

import Zope2
from ZODB.DB import DB
from ZODB.DemoStorage import DemoStorage

class StorageStackingTestCase(PloneTestCase.PloneTestCase):
    
    def beforeSetUp(self):
        PloneTestCase.PloneTestCase.beforeSetUp(self)

        # Wrap the configured database into a DemoStorage, later to be
        # unwrapped back again. Thanks to zc.selenium for inspiration.
        original_db, app_name, vc = Zope2.bobo_application._stuff
        databases = {}

        for db_name, db in original_db.databases.items():
            DB(DemoStorage(base=db._storage),
               databases=databases, database_name=db_name,
               )

        new_db = databases[original_db.database_name]
        new_db.pushed_base = original_db # hacking extra attr onto db
        Zope2.bobo_application._stuff = (new_db, app_name, vc)

    def beforeClose(self):
        # Restore the original database.
        hacked_db, app_name, vc = Zope2.bobo_application._stuff
        Zope2.bobo_application._stuff = (hacked_db.pushed_base, app_name, vc)

        PloneTestCase.PloneTestCase.beforeClose(self)
